<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 01/04/14
 * Time: 16:08
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Logic;
require_once __DIR__.'../../../../../projects/scheduler/public/bootstrap.php';
require_once 'Zend/Mail.php';
require_once 'Zend/Mail/Transport/Smtp.php';
require_once 'MailSender.php';

class ReportSender{


    const INFO_QUERY="SELECT CDOPERADOR, CDOPERPAINEL, PARAMETROS FROM PAINELEMAIL WHERE NRPAINEL=:P_NRPAINEL AND NRORG=:P_NRORG";

    const MAIL_QUERY="SELECT DSEMAILOPER FROM OPERADOR WHERE CDOPERADOR=:P_CDOPERADOR AND NRORG=:P_NRORG";

    const LANG_QUERY="SELECT TRADIDIOMA.CDTRADIDIOMAIS FROM TRADIDIOMA INNER JOIN OPERADOR ON
        OPERADOR.IDIDIOMA=TRADIDIOMA.IDIDIOMA WHERE OPERADOR.CDOPERADOR=:P_CDOPERADOR AND OPERADOR.NRORG=:P_NRORG";

    const PARAM_QUERY="SELECT PARAMETER_NAME, PARAMETER_HAS_DEFAULT, PARAMETER_EVAL_EXPRESSION FROM TKU_REPORT_PARAM
            WHERE NRPAINEL=:P_NRPAINEL";

    private static $fullpath;

    private static $logoURL;

    protected static $NRORG;

    protected static $operPainel;

    protected static $body= "Bom dia! <br/> Segue o relatório das atividades diárias da unidade. ";

    public static function setLogoURL($logoURL)
    {
        self::$logoURL = $logoURL;
    }

    public static function getLogoURL()
    {
        return self::$logoURL;
    }

    public static function setFullPath($fullpath)
    {
        self::$fullpath = $fullpath;
    }

    public static function getFullPath()
    {
        return self::$fullpath;
    }

    public static function setBody($body)
    {
        self::$body = $body;
    }

    public static function getBody()
    {
        return self::$body;
    }

    public static function setNrorg($nrorg){
        self::$NRORG=$nrorg;
    }

    public static function getNrorg(){
        if(!empty(self::$NRORG)) {
            return self::$NRORG;
        }
        else {
            self::$NRORG=1;
            return self::$NRORG;
        }

    }

    public static function getUrlLogoCliente(){

        if(empty(self::$logoURL)){
            $db = \Setforms2\Runtime\Connection::getInstance();
            $logoURLReturn = $db->fetchAll("SELECT URLLOGOCLIENTE FROM PARAMGERAL WHERE NRORG=:P_NRORG",
                Array('P_NRORG' => self::getNrorg()));

            $logoURL = $logoURLReturn[0]['URLLOGOCLIENTE'] . '/' . self::getNrorg() . '-logo.png';

            if (!empty($logoURL)) {
                self::$logoURL = $logoURL;
                return $logoURL;
            }else{
                $configs = parse_ini_file(__DIR__ . '/../../../../projects/scheduler/config/config.ini');
                self::$logoURL = $configs['logo_path'] . '/' . self::getNrorg() . '-logo.png';
                return self::$logoURL;
            }
        }
        else{
            return self::$logoURL;
        }
    }

    public static function setCdOperadorRelatorio($operPainel){
        self::$operPainel=$operPainel;
    }

    public static function getCdOperadorRelatorio(){
        return self::$operPainel;
    }

    /**
     * Envia um relatório via e-mail para todos os operadores descritos em PAINELEMAIL para aquele relatório.
     * @param $parametros
     *  Um array associativo(em forma de array mesmo ou de JSON com htmlspecialchars) com os seguintes parâmetros:
     *   -REPORT Código do relatório em PAINEL
     *   -BODY Corpo da mensagem que será enviada
     *   -TEMPLATE(opcional) Template que o e-mail vai ter
     * @param int $nrorg
     *  A NRORG que será usada para consultas ao banco, etc
     */
    public static function mandar_relatorio($parametros,$nrorg=1){

        //se $parametros não for um array, assume que é um JSON codificado pelo setforms e decodifica
        if (!is_array($parametros)){
            $array_parametros=\Scheduler\Util\ConsumerFunctions::decodeEscapedJson($parametros);
        }
        //se for, utiliza-se $parametros
        else{
            $array_parametros=$parametros;
        }

        self::setFullPath(realpath(__DIR__.'/../../../../projects/scheduler/config/config.ini'));

        self::setNrorg($nrorg);

        if (!empty($array_parametros["BODY"])) self::setBody($array_parametros["BODY"]);

        $queryParams['P_NRORG']=$nrorg;  //é utilizado em quase todas as queries

        $reportParameterArray["URL_LOGO_CLIENTE"]=self::getLogoURL();

        $db=\Setforms2\Runtime\Connection::getInstance();
        /* pega os registros em PAINELEMAIL relativos ao report
         * Em PAINELEMAIL, cada registro é uma combinação de destinatário, operador a qual o relatório se refere e
         * o relatório propriamente dito.
         * Note que mesmo que o relatório não utilize qualquer código de operador,
         * ele ainda terá um "operador do painel", que será ignorado quando o report for efetivamente gerado
         */
        $queryParams['P_NRPAINEL']=$array_parametros["REPORT"]; //pega os registros em PAINELEMAIL relativos ao report
        $infoPainel=$db->fetchAll(self::INFO_QUERY, $queryParams);

        //para cada registro em painelemail buscado, manda um relatório
        foreach($infoPainel as $info){

            //seta os parâmetros que serão utilizados para gerar o report
            //$reportParameterArray é passado para o Report em ReportMail
            //note que nem todos os parâmetros são usados por todos os relatórios

            $queryParams["P_CDOPERADOR"]=$info['CDOPERADOR'];   //pega o e-mail relacionado ao código do destinatário
            $mailList=$db->fetchAll(self::MAIL_QUERY, $queryParams);

            $languageResult=$db->fetchAll(self::LANG_QUERY, $queryParams); //pega a língua do destinatário do relatório
            $language=$languageResult[0]["CDTRADIDIOMAIS"];
            if (empty($language)) $language="pt_BR";  //se não houver, assume pt_BR

            //cada um desses dois parâmetros é usado por um relatório diferente
            $reportParameterArray["P_CDGOPERAC"]=$info['CDOPERPAINEL'];
            $reportParameterArray["P_CDGUNIDADE"]=$info['CDOPERPAINEL'];

            $reportParameterArray["P_NRORG"]=self::getNrorg();

            $yesterday=new \Datetime("yesterday");
            if($array_parametros["REPORT"]!=41){
                //buildDateParametersFromInterval automaticamente retorna o primeiro dia do mês para DATAFIM
                //os outros relatórios precisam de um intervalo de tempo que compreenda o mês corrente, logo
                //se usa um intervalo de 0
                $reportParameterArray+=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P0M", $yesterday);
            }else{   //só o report 41 utiliza um período de 1 ano ao invés de 1 mês
                $reportParameterArray+=\Scheduler\Util\ReportParameterFunctions::buildDateParametersFromInterval("P1Y", $yesterday);
            }

            $extraParams=explode("\n", $info["PARAMETROS"]);
            foreach($extraParams as $paramLine){
                $singleParamArray=explode("=", $paramLine);
                $reportParameterArray[$singleParamArray[0]]=$singleParamArray[1];
            }

            //pega o nome real do painel com código $reportCode
            $reportNameResult=$db->fetchAll("SELECT NMINTERNOPAINEL FROM PAINEL WHERE NRPAINEL=:P_NRPAINEL",$queryParams);

            //extrai o nome do array resultado da query (cada registro é 1 posição)
            $reportName=$reportNameResult[0]["NMINTERNOPAINEL"];

            $mail = new \Scheduler\Logic\ReportMail();
            $mail->setReportParameters($reportParameterArray);
            $mail->attachReport($reportName, $language);
            $mail->addTo($mailList[0]["DSEMAILOPER"]);

            //Se $array_parametros tiver ["TEMPLATE"], utiliza ele como template
            if (isset($array_parametros["TEMPLATE"])){
                $mail->setTemplate($array_parametros["TEMPLATE"]);
                $mail->buildTemplate(self::getBody(),self::getLogoURL());
            }
            else{ //se não, só coloca ["BODY"] no e-mail
                $mail->setBody(self::getBody());
            }

            //pega o nome do report que vai ser enviado, pra colocar como assunto do e-mail
            $subject=self::getReportName($array_parametros["REPORT"]);
            $mail->setSubject($subject);

//            $mail->sendMail();

        }
    }

//    /**
//     * seta uma variedade de parâmetros que serão usados p/ enviar os relatórios
//     * @param $db
//     *   uma instância de \Setforms2\Runtime\Connection; só pra reaproveitar a invocação
//     */
//    private static function initParameters(){
//
//        $db=\Setforms2\Runtime\Connection::getInstance();
//
//        self::setFullPath(realpath(__DIR__.'/../../../../projects/scheduler/config/config.ini'));
//
//
//    }

    public static function getReportName($report){
        switch ($report){

            case 11: $name="Painel - Gerente Operacional"; break;

            case 31: $name="Painel - Resumo Gerencial"; break;

            case 32: $name="Painel - Analise Gerencial"; break;

            default: $name="Painel de Indicadores"; break;

        }

        return $name;
    }

    //não é mais utilizado, mas pode vir a ser útil
    public static function getFileName($url){
        $firstExplode=explode(".rptdesign",$url);
//        $secondExplode=explode("=",$firstExplode[0]);
        $secondExplode=explode("=",$firstExplode[0]);
        $thirdExplode=explode("/",$secondExplode[1]);
        $filename=array_pop($thirdExplode);
        return $filename;
    }

}

//ReportSender::mandar_relatorio("{&quot;SENDER&quot;:&quot;geovane.santos@teknisa.com&quot;,&quot;RECIPIENT&quot;:&quot;giovanni.salvador@teknisa.com&quot;,&quot;SUBJECT&quot;:&quot;teste&quot;,&quot;BODY&quot;:&quot;teste&quot;,&quot;REPORT&quot;:&quot;http:\/\/192.168.122.62:9191\/birt-viewer\/frameset?__report=painel_go_2.rptdesign&amp;P_DATA=30\/03\/2013&amp;P_CDGRUPOGO=001&amp;P_CDGOPERAC=000042106720&amp;__format=pdf&quot;}");
//ReportSender::mandar_relatorio("{&quot;REPORT&quot;:&quot;11&quot;,&quot;BODY&quot;:&quot;Segue relat\u00f3rio relativo ao gerente Operacional&quot;,&quot;NRORG&quot;:1}");