/*+
|                                               |
|     Trigger: DTULTATU_PARGERALSUV             |  
|     Tabela : PARGERALSUV                      |
|                                               |
|     Criao:                                  |
|     31/03/2009 - Leonardo Bispo               |
|                                               |
+*/

create or replace TRIGGER DTULTATU_PARGERALSUV
BEFORE INSERT OR UPDATE OR DELETE
ON PARGERALSUV FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPAGESUV := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILSOLISUP,0) <> NVL(:NEW.CDFILSOLISUP,0)) OR
         (NVL(:OLD.CDGRUPPRODDESP,0) <> NVL(:NEW.CDGRUPPRODDESP,0)) OR
         (NVL(:OLD.CDTIPOSUPRIDEVO,0) <> NVL(:NEW.CDTIPOSUPRIDEVO,0)) OR
         (NVL(:OLD.CDTIPOSUPRIREEM,0) <> NVL(:NEW.CDTIPOSUPRIREEM,0)) OR
         (NVL(:OLD.CDSERIEENTR,0) <> NVL(:NEW.CDSERIEENTR,0)) OR
         (NVL(:OLD.CDSUBGRPRODDESP,0) <> NVL(:NEW.CDSUBGRPRODDESP,0)) OR
         (NVL(:OLD.IDENTRSAIDOPEN,0) <> NVL(:NEW.IDENTRSAIDOPEN,0)) OR
         (NVL(:OLD.CDTIPOOPERPAG,0) <> NVL(:NEW.CDTIPOOPERPAG,0)) OR
         (NVL(:OLD.IDENTRSAIDOPSA,0) <> NVL(:NEW.IDENTRSAIDOPSA,0)) OR
         (NVL(:OLD.CDTIPOOPERREC,0) <> NVL(:NEW.CDTIPOOPERREC,0)) OR
         (NVL(:OLD.DSSMTPEMAIL,0) <> NVL(:NEW.DSSMTPEMAIL,0)) OR
         (NVL(:OLD.DSEMAILORIGEM,0) <> NVL(:NEW.DSEMAILORIGEM,0)) OR
         (NVL(:OLD.CDSENHAEMAIL,0) <> NVL(:NEW.CDSENHAEMAIL,0)) THEN
              :NEW.DTULTATUPAGESUV := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARGERALSUV', '', 'NRPARGERALSUV='||:OLD.NRPARGERALSUV||';',  SYSDATE);
   END IF;
END;
/

ALTER TABLE PARGERALSUV MODIFY DTULTATUPAGESUV DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PARGERALSUV','5.07.015'); END;
/
