create or replace PROCEDURE ATUALIZA_DATACOMP_GERENCIAL
   (P_CDFILIAL    IN FILIAL.CDFILIAL%TYPE,
    P_DTINICIAL   IN DATE,
    P_DTFINAL     IN DATE) AS
   V_NRDIAREFEPER NUMBER;
   V_NRPERPRXMES  NUMBER;
   V_DTCOMPCUSTO  DATE;
   V_NRLANCCONT   VARCHAR2(20);
   V_COUNT        INTEGER;
   V_IDCONTCCUS   VARCHAR2(01);
   V_IDLANCCOME   LANCCONT.IDLANCCOME%TYPE;
   V_CDCONTCOME   LANCCONT.CDCONTCOME%TYPE;
   V_CDCENTCUST   LANCCCUSTO.CDCENTCUST%TYPE;
   V_COUNTPERIODO INTEGER;
BEGIN
   FOR F IN (
      SELECT C.CDFILIAL, C.CDCONTCTBL, C.CDCCTBREFE, CB.IDCONTCCUS, F.CDEMPRESA, F.CDCENTCUST
        FROM CCTBLGERFIL C, FILIAL F, CONTCTBL CB
       WHERE C.CDFILIAL = P_CDFILIAL
         AND C.CDFILIAL = F.CDFILIAL
         AND C.CDCCTBREFE = CB.CDCONTCTBL
   ) LOOP
      FOR C IN (
         SELECT DISTINCT L.NRLANCCONT, N.DTENTRSAID DTEMISSAO, TO_NUMBER(TO_CHAR(N.DTENTRSAID,'DD')) AS NRDIALANC
           FROM LANCCONT L, NOTAFISCAL N
          WHERE L.CDCONTCTBL = F.CDCCTBREFE
            AND L.CDEMPRESA = N.CDEMPRESA
            AND L.NRLANCCONT = N.NRLANCTBDOC
            AND N.IDENTRSAIDOP = 'E'
            AND N.CDFILIRECE = F.CDFILIAL
            AND N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL
          UNION ALL
         SELECT DISTINCT L.NRLANCCONT, N.DTEMISSAO, TO_NUMBER(TO_CHAR(N.DTENTRSAID,'DD')) AS NRDIALANC
           FROM LANCCONT L, NOTAFISCAL N
          WHERE L.CDCONTCTBL = F.CDCCTBREFE
            AND L.CDEMPRESA = N.CDEMPRESA
            AND L.NRLANCCONT = N.NRLANCTBDOC
            AND N.IDENTRSAIDOP = 'S'
            AND N.CDFILIEMIT = F.CDFILIAL
            AND N.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
          ORDER BY 1) LOOP
          
         SELECT NVL(MAX(NRDIAREFEPER),0), NVL(MAX(NRPERPRXMES),0)
           INTO V_NRDIAREFEPER, V_NRPERPRXMES
           FROM PERCTBGERFIL
          WHERE CDFILIAL = F.CDFILIAL
            AND C.NRDIALANC BETWEEN NRDIAINIPER AND NRDIAFIMPER;
            
         SELECT MAX(IDLANCCOME), MAX(CDCONTCOME)
           INTO V_IDLANCCOME, V_CDCONTCOME
           FROM LANCCONT
          WHERE CDEMPRESA = F.CDEMPRESA
            AND NRLANCCONT = C.NRLANCCONT;
         IF V_NRDIAREFEPER > 0 THEN
            IF V_NRDIAREFEPER >= 30 THEN
               V_DTCOMPCUSTO := LAST_DAY(C.DTEMISSAO);
            ELSE
               V_DTCOMPCUSTO := TO_DATE(LPAD(TO_CHAR(V_NRDIAREFEPER),2,'0')||TO_CHAR(C.DTEMISSAO, '/MM/YYYY'),'DD/MM/YYYY');
            END IF;
            IF V_NRPERPRXMES = 1 THEN
               V_DTCOMPCUSTO := ADD_MONTHS(V_DTCOMPCUSTO,1);
            END IF;
            FOR L IN (
               SELECT NRSEQLANC, CDCONTCTBL, CDHISTPADR,
                      DTLANCCONT, CDDOCUCONT, IDTIPOLANC,
                      DSHISTLANC, VRLANCAMENT,
                      IDLANCCOME, CDCONTCOME, IDLANCSALDO, IDLANCINTE,
                      IDLANCMANI, CDOPERINS, IDSALDLANCO, IDSALDLANGE,
                      NRLANCSALD, IDLANCONTEXP, DTULTATULAN
                 FROM LANCCONT
                WHERE CDEMPRESA = F.CDEMPRESA
                  AND NRLANCCONT = C.NRLANCCONT
                  AND CDCONTCTBL = F.CDCCTBREFE
                ORDER BY 1
            ) LOOP
               /* Busca o nmero do lanamento contbil*/
               NOVO_CODIGO_NT('LANCCONTABIL' || F.CDEMPRESA || TO_CHAR(V_DTCOMPCUSTO,'YYYYMM'), V_NRLANCCONT);
               V_NRLANCCONT := TO_CHAR(V_DTCOMPCUSTO,'YYYYMM')||SUBSTR(V_NRLANCCONT, 15, 6);
               INSERT INTO LANCCONT
                  (CDEMPRESA, NRLANCCONT, NRSEQLANC, CDCONTCTBL, CDHISTPADR,
                   DTLANCCONT, CDDOCUCONT, IDTIPOLANC, DSHISTLANC, VRLANCAMENT,
                   IDLANCCOME, CDCONTCOME, IDLANCSALDO, IDLANCINTE, IDLANCMANI,
                   CDOPERINS, DTULTATULAN, IDSALDLANCO, IDSALDLANGE, NRLANCSALD,
                   IDLANCONTEXP)
               VALUES
                  (F.CDEMPRESA, V_NRLANCCONT, '00001', F.CDCCTBREFE, L.CDHISTPADR,
                   V_DTCOMPCUSTO, L.CDDOCUCONT, L.IDTIPOLANC, L.DSHISTLANC, L.VRLANCAMENT,
                   L.IDLANCCOME, L.CDCONTCOME, L.IDLANCSALDO, L.IDLANCINTE, L.IDLANCMANI,
                   L.CDOPERINS, L.DTULTATULAN, L.IDSALDLANCO, L.IDSALDLANGE, L.NRLANCSALD,
                   L.IDLANCONTEXP);
               IF (F.IDCONTCCUS IN ('R','G')) THEN
                  FOR RAT IN
                     (SELECT CDFILIAL, CDCENTCUST, VRLANCCUST
                       FROM LANCCCUSTO LC
                      WHERE LC.CDEMPRESA  = F.CDEMPRESA
                        AND LC.NRLANCCONT = C.NRLANCCONT
                        AND LC.NRSEQLANC  = L.NRSEQLANC) LOOP
                     INSERT INTO LANCCCUSTO
                        (CDEMPRESA, NRLANCCONT, NRSEQLANC, CDFILIAL,
                         CDCENTCUST, VRLANCCUST, DTCOMPCUSTO, CDCONTCTBL)
                     VALUES
                        (F.CDEMPRESA, V_NRLANCCONT, '00001', RAT.CDFILIAL,
                         RAT.CDCENTCUST, RAT.VRLANCCUST, V_DTCOMPCUSTO, F.CDCCTBREFE);
                  END LOOP;
               END IF;
               INSERT INTO LANCCONT
                  (CDEMPRESA, NRLANCCONT, NRSEQLANC, CDCONTCTBL, CDHISTPADR,
                   DTLANCCONT, CDDOCUCONT, IDTIPOLANC, DSHISTLANC, VRLANCAMENT,
                   IDLANCCOME, CDCONTCOME, IDLANCSALDO, IDLANCINTE, IDLANCMANI,
                   CDOPERINS, DTULTATULAN, IDSALDLANCO, IDSALDLANGE, NRLANCSALD,
                   IDLANCONTEXP)
               VALUES
                  (F.CDEMPRESA, V_NRLANCCONT, '00002', F.CDCONTCTBL, L.CDHISTPADR,
                   V_DTCOMPCUSTO, L.CDDOCUCONT, L.IDTIPOLANC, L.DSHISTLANC, L.VRLANCAMENT * (-1),
                   V_IDLANCCOME, V_CDCONTCOME, L.IDLANCSALDO, L.IDLANCINTE, L.IDLANCMANI,
                   L.CDOPERINS, L.DTULTATULAN, L.IDSALDLANCO, L.IDSALDLANGE, L.NRLANCSALD,
                   L.IDLANCONTEXP);
               SELECT MAX(IDCONTCCUS)
                 INTO V_IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = F.CDCONTCTBL;
               IF (V_IDCONTCCUS IN ('R','G')) THEN
                  FOR RAT IN
                     (SELECT CDFILIAL, CDCENTCUST, VRLANCCUST
                        FROM LANCCCUSTO LC
                       WHERE LC.CDEMPRESA  = F.CDEMPRESA
                         AND LC.NRLANCCONT = C.NRLANCCONT
                         AND LC.NRSEQLANC  = L.NRSEQLANC) LOOP
                     INSERT INTO LANCCCUSTO
                        (CDEMPRESA, NRLANCCONT, NRSEQLANC, CDFILIAL,
                         CDCENTCUST, VRLANCCUST, DTCOMPCUSTO, CDCONTCTBL)
                     VALUES
                        (F.CDEMPRESA, V_NRLANCCONT, '00002', RAT.CDFILIAL,
                         RAT.CDCENTCUST, RAT.VRLANCCUST * (-1), V_DTCOMPCUSTO, F.CDCONTCTBL);
                  END LOOP;
               END IF;
               
               SELECT MAX(IDCONTCCUS)
                 INTO V_IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = F.CDCONTCTBL;
                
               SELECT COUNT(*)
                 INTO V_COUNT
                 FROM LANCCCUSTO
                WHERE CDEMPRESA = F.CDEMPRESA
                  AND NRLANCCONT = C.NRLANCCONT
                  AND NRSEQLANC = L.NRSEQLANC;
               IF V_IDCONTCCUS NOT IN ('R','G') THEN
                  IF V_COUNT > 0 THEN
                     DELETE FROM LANCCCUSTO
                      WHERE CDEMPRESA = F.CDEMPRESA
                        AND NRLANCCONT = C.NRLANCCONT
                        AND NRSEQLANC = L.NRSEQLANC;
                  END IF;
               END IF;
               UPDATE LANCCONT
                  SET CDCONTCTBL = F.CDCONTCTBL
                WHERE CDEMPRESA = F.CDEMPRESA
                  AND NRLANCCONT = C.NRLANCCONT
                  AND NRSEQLANC = L.NRSEQLANC;
            END LOOP;
         END IF;
      END LOOP;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_DATACOMP_GERENCIAL','5.33.xxx'); END;
/